﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Niwar.Framework.DomainModel
{
    /// <summary>
    /// 所有Entity需继承
    /// </summary>
    public abstract class BaseEntity : BaseObject
    {
        /// <summary>
        /// 添加时间
        /// </summary>
        public DateTime AddTime { get; set; }

        /// <summary>
        /// 添加人
        /// </summary>
        public string AddName { get; set; }

        /// <summary>
        /// 最后修改时间
        /// </summary>
        public DateTime? LastEditTime { get; set; }

        /// <summary>
        /// 最后修改人
        /// </summary>
        public string LastEditName { get; set; }

        public BaseEntity() {
            AddTime = DateTime.Now;
            AddName = "System";
        }
    }
}
